diff --git a/scite/win32/SciTEWin.cxx b/scite/win32/SciTEWin.cxx
index 8b0b69e..d0fc3ca 100644
--- a/scite/win32/SciTEWin.cxx
+++ b/scite/win32/SciTEWin.cxx
@@ -23,9 +23,9 @@
 #endif
 
 #ifdef STATIC_BUILD
-const GUI::gui_char appName[] = GUI_TEXT("Sc1");
+const GUI::gui_char appName[] = GUI_TEXT("SciTE4AutoHotkey Lite"); // fincs-edit
 #else
-const GUI::gui_char appName[] = GUI_TEXT("SciTE");
+const GUI::gui_char appName[] = GUI_TEXT("SciTE4AutoHotkey"); // fincs-edit
 #endif
 
 static GUI::gui_string GetErrorMessage(DWORD nRet) {
@@ -182,6 +182,11 @@ SciTEWin::SciTEWin(Extension *ext) : SciTEBase(ext) {
 	// System type properties are also stored in the embedded properties.
 	propsEmbed.Set("PLAT_WIN", "1");
 	propsEmbed.Set("PLAT_WINNT", "1");
+#ifdef _WIN64
+	propsEmbed.Set("PLAT_WIN64", "1");
+#else
+	propsEmbed.Set("PLAT_WIN32", "1");
+#endif
 
 	HRSRC handProps = ::FindResource(hInstance, TEXT("Embedded"), TEXT("Properties"));
 	if (handProps) {
@@ -203,7 +208,8 @@ SciTEWin::SciTEWin(Extension *ext) : SciTEBase(ext) {
 
 	SetScaleFactor(0);
 
-	tbLarge = props.GetInt("toolbar.large");
+	extern int g_ScreenDPI;
+	tbLarge = props.GetInt("toolbar.large", g_ScreenDPI >= 120);
 	/// Need to copy properties to variables before setting up window
 	SetPropertiesInitial();
 	ReadAbbrevPropFile();
@@ -249,12 +255,14 @@ void SciTEWin::Register(HINSTANCE hInstance_) {
 
 	// Register the frame window
 	className = TEXT("SciTEWindow");
-	wndclass.style = 0;
+	wndclass.style = CS_DBLCLKS; // fincs-edit
 	wndclass.lpfnWndProc = SciTEWin::TWndProc;
 	wndclass.cbClsExtra = 0;
 	wndclass.cbWndExtra = sizeof(SciTEWin*);
 	wndclass.hInstance = hInstance;
-	wndclass.hIcon = ::LoadIcon(hInstance, resourceName);
+	// fincs-edit
+	//wndclass.hIcon = ::LoadIcon(hInstance, resourceName);
+	wndclass.hIcon = (HICON) ::LoadImage(hInstance, MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, 0, 0, LR_SHARED);
 	wndclass.hCursor = NULL;
 	wndclass.hbrBackground = NULL;
 	wndclass.lpszMenuName = resourceName;
@@ -436,10 +444,82 @@ FilePath SciTEWin::GetSciteDefaultHome() {
 	return GetSciTEPath(home);
 }
 
+// fincs-edit START
+static bool _FileExistsInSciTEDir(PCWSTR aFileName)
+{
+	wchar_t aBuf[MAX_PATH+1];
+	wchar_t* aBufPtr = aBuf;
+
+	GetModuleFileNameW(NULL, aBuf, MAX_PATH+1);
+	aBufPtr += wcslen(aBuf);
+	while(*--aBufPtr != '\\');
+	wcscpy(aBufPtr+1, aFileName);
+
+	return GetFileAttributes(aBuf) != INVALID_FILE_ATTRIBUTES;
+}
+
+bool _IsPortable()
+{
+	static bool bInit = false, ret = false;
+	if (!bInit)
+	{
+		bInit = true;
+		ret = _FileExistsInSciTEDir(L"$PORTABLE");
+	}
+	return ret;
+}
+
+bool _IsDeveloper()
+{
+	static bool bInit = false, ret = false;
+	if (!bInit)
+	{
+		bInit = true;
+		ret = _FileExistsInSciTEDir(L"$DEV");
+	}
+	return ret;
+}
+
+bool _IsProtectedFile(FilePath file)
+{
+	if (_IsPortable() || _IsDeveloper()) return false;
+	GUI::gui_string basePath = GetSciTEPath(FilePath()).AsInternal();
+	basePath.append(GUI_TEXT("\\"));
+	return wcsncmp(file.AsInternal(), basePath.c_str(), basePath.length()) == 0
+		&& !file.Name().SameNameAs(FilePath(GUI_TEXT("TestSuite.ahk")));
+}
+// fincs-edit END
+
 FilePath SciTEWin::GetSciteUserHome() {
+	bool is_portable = _IsPortable(); // fincs-edit
+
 	GUI::gui_char *home = _wgetenv(GUI_TEXT("SciTE_HOME"));
 	if (!home)
-		home = _wgetenv(GUI_TEXT("USERPROFILE"));
+	{ // fincs-edit START
+		WCHAR szPath[MAX_PATH+1];
+		bool success = false;
+		
+		if(!is_portable)
+		{
+			if(SUCCEEDED(::SHGetFolderPathW(NULL, CSIDL_PERSONAL|CSIDL_FLAG_CREATE, NULL, 0, szPath)))
+			{
+				::PathAppendW(szPath, GUI_TEXT("AutoHotkey\\SciTE"));
+				home = szPath;
+				success = true;
+			}
+		}else
+		{
+			::GetModuleFileNameW(NULL, szPath, MAX_PATH+1);
+			::PathRemoveFileSpecW(szPath);
+			::PathAppendW(szPath, GUI_TEXT("user"));
+			home = szPath;
+			success = true;
+		}
+
+		if(!success)
+			home = _wgetenv(GUI_TEXT("USERPROFILE"));
+	} // fincs-edit END
+
 	return GetSciTEPath(home);
 }
 
@@ -591,6 +671,10 @@ HWND SciTEWin::MainHWND() {
 	return HwndOf(wSciTE);
 }
 
+HWND SciTEWin::ToolHWND() { // fincs-edit
+	return reinterpret_cast<HWND>(wToolBar.GetID()); // fincs-edit
+} // fincs-edit
+
 void SciTEWin::Command(WPARAM wParam, LPARAM lParam) {
 	int cmdID = ControlIDOfWParam(wParam);
 	if (wParam & 0x10000) {
@@ -1436,6 +1520,21 @@ void SciTEWin::Run(const GUI::gui_char *cmdLine) {
 		return;	// Don't do anything else
 	}
 
+#ifndef STATIC_BUILD
+	// fincs-edit
+	do
+	{
+		std::string sMainHwnd = StdStringFromSizeT(reinterpret_cast<size_t>(MainHWND()));
+		props.Set("scite.hwnd", sMainHwnd.c_str());
+
+		std::string autorun = props.GetExpandedString("command.autorun");
+		if (autorun.length() == 0)
+			break;
+
+		ShellExec(autorun, "");
+	} while(0);
+#endif
+
 	// OK, the instance will be displayed
 	SizeSubWindows();
 	wSciTE.Show();
@@ -1868,6 +1967,10 @@ LRESULT SciTEWin::WndProc(UINT iMessage, WPARAM wParam, LPARAM lParam) {
 			WorkerCommand(static_cast<int>(wParam), reinterpret_cast<Worker *>(lParam));
 			break;
 
+		case WM_LBUTTONDBLCLK: // fincs-edit
+			::SendMessage(MainHWND(), WM_COMMAND, IDM_NEW, 0);
+			return 0;
+
 		case WM_NOTIFY:
 			Notify(reinterpret_cast<SCNotification *>(lParam));
 			break;
@@ -1966,6 +2069,20 @@ LRESULT SciTEWin::WndProc(UINT iMessage, WPARAM wParam, LPARAM lParam) {
 		case WM_COPYDATA:
 			return uniqueInstance.CopyData(reinterpret_cast<COPYDATASTRUCT *>(lParam));
 
+		case WM_USER: // fincs-edit
+			SIZE uTSize; // fincs-edit
+			::SendMessage(ToolHWND(), TB_GETMAXSIZE, 0, (LPARAM)&uTSize); // fincs-edit
+			return (LRESULT) uTSize.cx; // fincs-edit
+
+		case WM_USER+1: // fincs-edit
+			ReloadProperties(); // fincs-edit
+			return 0l; // fincs-edit
+
+		case WM_USER+2: // fincs-edit, yet again
+			debugging = !!wParam;
+			SetWindowName();
+			break;
+
 		default:
 			return ::DefWindowProcW(MainHWND(), iMessage, wParam, lParam);
 		}
@@ -2129,6 +2246,20 @@ uptr_t SciTEWin::EventLoop() {
 #pragma warning(disable: 28251)
 #endif
 
+// fincs-edit START
+
+static int GetScreenDPI()
+{
+	HDC hdc = GetDC(NULL);
+	int dpi = GetDeviceCaps(hdc, LOGPIXELSX);
+	ReleaseDC(NULL, hdc);
+	return dpi;
+}
+
+int g_ScreenDPI = GetScreenDPI();
+
+// fincs-edit END
+
 int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int) {
 
 	typedef BOOL (WINAPI *SetDllDirectorySig)(LPCTSTR lpPathName);
diff --git a/scite/win32/SciTEWin.h b/scite/win32/SciTEWin.h
index c4ed7e1..bff6686 100644
--- a/scite/win32/SciTEWin.h
+++ b/scite/win32/SciTEWin.h
@@ -44,12 +44,13 @@ typedef void *HTHEME;
 #endif
 #include <commctrl.h>
 #include <richedit.h>
-#include <shlwapi.h>
 
 #include <io.h>
 #include <process.h>
 #include <mmsystem.h>
 #include <commctrl.h>
+#include <shlobj.h>
+#include <shlwapi.h>
 
 #if defined(DTBG_CLIPRECT) && !defined(DISABLE_THEMES)
 #define THEME_AVAILABLE
@@ -309,6 +310,7 @@ protected:
 	void FullScreenToggle();
 	void Command(WPARAM wParam, LPARAM lParam);
 	HWND MainHWND();
+	HWND ToolHWND(); // fincs-edit
 
 	virtual void UserStripShow(const char *description);
 	virtual void UserStripSet(int control, const char *value);
diff --git a/scite/win32/SciTEWinBar.cxx b/scite/win32/SciTEWinBar.cxx
index 61184a4..fba7dbf 100644
--- a/scite/win32/SciTEWinBar.cxx
+++ b/scite/win32/SciTEWinBar.cxx
@@ -892,7 +892,7 @@ void SciTEWin::Creation() {
 	              tbLarge ? IDB_STD_LARGE_COLOR : IDB_STD_SMALL_COLOR,
 	              reinterpret_cast<LPARAM>(HINST_COMMCTRL));
 
-	TBADDBITMAP addbmp = { hInstance, IDR_CLOSEFILE };
+	TBADDBITMAP addbmp = { hInstance, tbLarge ? IDR_CLOSEFILE_BIG : IDR_CLOSEFILE };
 	::SendMessage(hwndToolBar, TB_ADDBITMAP, 1, (LPARAM)&addbmp);
 
 	TBBUTTON tbb[ELEMENTS(bbs)];
diff --git a/scite/win32/SciTEWinDlg.cxx b/scite/win32/SciTEWinDlg.cxx
index 6a8c046..d3d0ce2 100644
--- a/scite/win32/SciTEWinDlg.cxx
+++ b/scite/win32/SciTEWinDlg.cxx
@@ -250,6 +250,11 @@ bool SciTEWin::OpenDialog(FilePath directory, const GUI::gui_char *filesFilter)
 	if (props.GetInt("open.dialog.in.file.directory")) {
 		ofn.lpstrInitialDir = directory.AsInternal();
 	}
+	// fincs-edit START
+	GUI::gui_string defExt = GUI::StringFromUTF8(props.GetExpandedString("default.file.ext"));
+	if (defExt.length() > 0)
+		ofn.lpstrDefExt = defExt.c_str() + 1;
+	// fincs-edit END
 	ofn.Flags = OFN_HIDEREADONLY;
 
 	if (buffers.size > 1) {
@@ -301,6 +306,11 @@ FilePath SciTEWin::ChooseSaveName(FilePath directory, const char *title, const G
 		ofn.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR;
 		ofn.lpstrFilter = filesFilter;
 		ofn.lpstrInitialDir = directory.AsInternal();
+		// fincs-edit START
+		GUI::gui_string defExt = GUI::StringFromUTF8(props.GetExpandedString("default.file.ext"));
+		if (defExt.length() > 0)
+			ofn.lpstrDefExt = defExt.c_str() + 1;
+		// fincs-edit END
 
 		dialogsOnScreen++;
 		if (::GetSaveFileNameW(&ofn)) {
@@ -318,6 +328,17 @@ bool SciTEWin::SaveAsDialog() {
 		GUI::StringFromUTF8(props.GetExpandedString("save.filter")).c_str());
 	FilePath path = ChooseSaveName(filePath.Directory(), "Save File", saveFilter.c_str());
 	if (path.IsSet()) {
+		extern bool _IsProtectedFile(FilePath);
+		if (_IsProtectedFile(path))
+		{
+			GUI::gui_string msg = LocaliseMessage(
+				"Folder '^0' is reserved for SciTE4AutoHotkey program files.\n\n"
+				"The SciTE4AutoHotkey program folder is deleted and repopulated everytime the program is updated. "
+				"In order to prevent data loss, please select another one."
+				, path.Directory().AsInternal());
+			WindowMessageBox(wSciTE, msg);
+			return SaveAsDialog();
+		}
 		return SaveIfNotOpen(path, false);
 	}
 	return false;
@@ -1697,7 +1718,7 @@ BOOL SciTEWin::AboutMessage(HWND hDlg, UINT message, WPARAM wParam) {
 		LONG_PTR subclassedProc = ::SetWindowLongPtr(hwndCredits, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(CreditsWndProc));
 		::SetWindowLongPtr(hwndCredits, GWLP_USERDATA, subclassedProc);
 		ss.SetID(hwndCredits);
-		SetAboutMessage(ss, staticBuild ? "Sc1  " : "SciTE");
+		SetAboutMessage(ss, staticBuild ? "SciTE4AutoHotkey Lite" : "SciTE4AutoHotkey"); // fincs-edit
 		}
 		return TRUE;
 
diff --git a/scite/win32/Strips.cxx b/scite/win32/Strips.cxx
index 30e9aff..54eeec8 100644
--- a/scite/win32/Strips.cxx
+++ b/scite/win32/Strips.cxx
@@ -97,6 +97,7 @@ static const char *textFindPrompt = "Fi&nd:";
 static const char *textReplacePrompt = "Rep&lace:";
 static const char *textFindNext = "&Find Next";
 static const char *textMarkAll = "&Mark All";
+static const char *textUnmarkAll = "&Unmark All";
 
 static const char *textReplace = "&Replace";
 static const char *textReplaceAll = "Replace &All";
@@ -962,6 +963,7 @@ void FindStrip::Creation() {
 
 	wButton = CreateButton(textFindNext, IDOK);
 	wButtonMarkAll = CreateButton(textMarkAll, IDMARKALL);
+	wButtonUnmarkAll = CreateButton(textUnmarkAll, IDM_BOOKMARK_CLEARALL);
 
 	wCheckWord = CreateButton(toggles[SearchOption::tWord].label, toggles[SearchOption::tWord].id, true);
 	wCheckCase = CreateButton(toggles[SearchOption::tCase].label, toggles[SearchOption::tCase].id, true);
@@ -1010,6 +1012,10 @@ void FindStrip::Size() {
 	wCheckWord.SetPosition(rcButton);
 
 	rcButton.right = rcButton.left - 4;
+	rcButton.left = rcButton.right - WidthControl(wButtonUnmarkAll);
+	wButtonUnmarkAll.SetPosition(rcButton);
+
+	rcButton.right = rcButton.left - 4;
 	rcButton.left = rcButton.right - WidthControl(wButtonMarkAll);
 	wButtonMarkAll.SetPosition(rcButton);
 
@@ -1110,6 +1116,9 @@ bool FindStrip::Command(WPARAM wParam) {
 	} else if (control == IDMARKALL) {
 		Next(true, false);
 		return true;
+	} else if (control == IDM_BOOKMARK_CLEARALL) {
+		pSearcher->ClearAllBookmarks();
+		return true;
 	} else if (control == IDFINDWHAT) {
 		if (subCommand == CBN_EDITCHANGE) {
 			NextIncremental(changingEdit);
diff --git a/scite/win32/Strips.h b/scite/win32/Strips.h
index e360f4f..a7d19fd 100644
--- a/scite/win32/Strips.h
+++ b/scite/win32/Strips.h
@@ -159,6 +159,7 @@ public:
 class FindStrip : public FindReplaceStrip {
 	GUI::Window wButton;
 	GUI::Window wButtonMarkAll;
+	GUI::Window wButtonUnmarkAll;
 	GUI::Window wCheckUp;
 public:
 	FindStrip() {
